#!/bin/bash
# #!/usr/bin/ksh
# #!/bin/bash

###############################################################################
#                                                                             #
#   libHelp.sh : A script that show Headers of functions.                     #
#                                                                             #
#   +---------------------------------------------------------------------+   #
#   | Copyright (c) 2010 Flyounet                                         |   #
#   +---------------------------------------------------------------------+   #
#   | This program is free software: you can redistribute it and/or       |   #
#   | modify it under the terms of the GNU General Public License as      |   #
#   | published by the Free Software Foundation, either version 3 of the  |   #
#   | License, or (at your option) any later version.                     |   #
#   |                                                                     |   #
#   | This program is distributed in the hope that it will be useful,     |   #
#   | but WITHOUT ANY WARRANTY; without even the implied warranty of      |   #
#   | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       |   #
#   | GNU General Public License for more details.                        |   #
#   |                                                                     |   #
#   | You should have received a copy of the GNU General Public License   |   #
#   | along with this program.                                            |   #
#   | If not, see <http://www.gnu.org/licenses/>.                         |   #
#   +---------------------------------------------------------------------+   #
#   | Cette œuvre est distribuée SANS AUCUNE GARANTIE hormis celle d'être |   #
#   | distribuée sous les termes de la License Demerdez-vous ("Demerden   |   #                                  
#   | Sie Sich License") plusommunément appelée DSSL telle que publiée    |   #                                  
#   | par Flyounet : soit la version 1 de cette licence, soit (à votre    |   #                                  
#   | gré) toute version ultérieure.                                      |   #                                  
#   |                                                                     |   #                                  
#   | Vous devriez avoir reçu une copie de la Licence Démerdez-vous avec  |   #                                  
#   | cette œuvre ; si ce n’est pas le cas, consultez :                   |   #                                  
#   | <http://dssl.flyounet.net/licenses/>.                               |   #
#   +---------------------------------------------------------------------+   #
#   | Author: Flyounet  < dev @@ flyounet . net >                         |   #
#   +---------------------------------------------------------------------+   #
#                                                                             #
###############################################################################
#                                                                             #
# v0.01 [09/04/2010] Flyounet  [@Home] :                                      #
#       > Initiale Release                                                    #
#       > Prerequisites : F01 common.lib >v0.26                               #
#                                                                             #
###############################################################################
#                                                                             #
# Todo :                                                                      #
#                                                                             #
###############################################################################
#                                                                             #
# Legende :                                                                   #
#  + --> Indique une nouveaute, un ajout de fonctionnalite.                   #
#  * --> Indique une correction de bogue.                                     #
#  - --> Indique la suppression d'une fonctionnalite/variable.                #
#  > --> Indique une information n'ayant pas forcement de rapport avec le code#
#  < --> Indique une amelioration a apporter au code.                         #
# <- --> Indique une amelioration en cours de developpement/realisation.      #
# OK --> Indique qu'une amelioration a ete effectuee.                         #
#                                                                             #
###############################################################################

# As Prerequisites the Library F01 common.lib is needed
. "$(cd ${0%/*}; pwd)/../common.lib"

#Fxx.01.01
#function : verifyLibs, Verify if needed libraries are well loaded, else quit
#syntaxe  : verifyLibs
#return   : nothing
#notes    : Verify if the F0xVersion exists
#notes    : This function is called just after its definition.
verifyLibs () {
	if [ "F01Version" != "$(command -v "F01Version")" ]
	then
		printf -- "\E[01;31mError !\E[0m Library 'F01common.lib' is not loaded !\n"
		exit 1
	fi
}
verifyLibs

parseHeadersForHelp ${@}

exit 0

# +---------------------------------------------------------------------------+ #
# | Last subversion informations :                                      
# | $Revision: 10 $ : $Date: 2010-03-29 18:21:12 +0200 (lun. 29 mars 2010) $                                                     
# | $Author: Flyounet $
# +---------------------------------------------------------------------------+ #
